//generated class! do not change
class InmutableList {
  private boolean empty = true;
  private Object  hd;
  private InmutableList tl;
 
  public InmutableList(){}
  public InmutableList(Object x,InmutableList xs){
   hd = x;
   tl = xs;
   empty = false;
  }

  public boolean isEmpty() {return empty;}  
  public Object  head(){return hd;}
  public InmutableList tail(){return tl;}

  public int length(){
    if (isEmpty())return 0;
    return 1+tail().length();
  }

  public String toString(){
    return "("+toStringAux()+")";
  }
  private String toStringAux(){
    if (isEmpty()) return "";
    else if (tail().isEmpty()) return head().toString();
    else return head().toString()+","+tail().toStringAux();
  }

  public InmutableList append(InmutableList ys){
    if (isEmpty()) return ys;
    return new InmutableList(head(),tail().append(ys));
  }

  public InmutableList filter(FilterCondition cond){
    InmutableList result = new InmutableList();

    for (InmutableList xs=this;!xs.isEmpty();xs=xs.tail()){
      if (cond.condition(xs.head())) {
        result = new InmutableList(xs.head(),result);
      }
    }
    return result;
  }

  public InmutableList sortBy(Relation rel){
    if (!isEmpty()){ 
      final FilterCondition le
       = new OrderingCondition(head(),rel);
      final FilterCondition gr
       = new NegativeOrderingCondition(head(),rel);
      final InmutableList smaller = tail().filter(le).sortBy(rel);
      final InmutableList greater = tail().filter(gr).sortBy(rel);
      return smaller.append(new InmutableList(head(),greater));
    }
    return new InmutableList();
  }
}

