//generated class! do not change
class Li {
  boolean empty = true;
  Object  hd;
  Li      tl;
 
  Li (){}

  Li (Object x,Li xs){
   hd = x;
   tl = xs;
   empty = false;
  }

  boolean isEmpty() {return empty;}  
  Object  head(){return hd;}
  Li      tail(){return tl;}

  int length(){
    if (isEmpty())return 0;
    return 1+tail().length();
  }

  int lengthWhile(){
    int erg=0;
    Li xs = this;
    while (!xs.isEmpty()){
      erg= erg +1;
      xs = xs.tail();
    }
    return erg;
  }

  int lengthFor(){
    int erg=0;
    for (Li xs=this;!xs.isEmpty();xs=xs.tail()){
      erg = erg +1;
    }
    return erg;
  }

  public String toString(){
    return "("+toStringAux()+")";
  }

  private String toStringAux(){
    if (isEmpty()) return "";
    else if (tail().isEmpty()) return head().toString();
    else return head().toString()+","+tail().toStringAux();
  }

Li append(Li ys){
  if (isEmpty())return ys;
  return new Li(head(),tail().append(ys));
}

  Li filter(FilterCondition cond){
    Li result = new Li();

    //test all elements of this list
    for (Li xs=this;!xs.isEmpty();xs=xs.tail()){

      //in case that the condition is true for the element
      if (cond.condition(xs.head())) {
        //then add it to the result
        result = new Li(xs.head(),result);
      }
    }
    return result;
  }

  Li quicksort(){
    Li result = new Li();
    if (!isEmpty()){ 
      result 
       =   //filter the smaller elements out of the tail
           tail().filter(new LessEqualX((String)head()))
            //sort these
            .quicksort()
            //concatenate it with the sorted 
            //sublist of greater elements
            .append(new Li(head()
                   ,tail().filter(new GreaterX((String)head()))
                    .quicksort()
              ));
    }
    return result;
  }

  Li sortBy(Relation rel){
    Li result = new Li();
    if (!isEmpty()){ 
      FilterCondition le
       = new OrderingCondition(head(),rel);
      FilterCondition gr
       = new NegativeOrderingCondition(head(),rel);
      result = tail()
                .filter(le)
                .sortBy(rel)
                .append(new Li(head()
                              ,tail()
                                 .filter(gr)
                                 .sortBy(rel)));
    }
    return result;
  }
}

